using Homework.Barking;
using Homework.Movement;
using UnityEngine;

namespace Homework.Dogs
{
    /**
     * TODO:
     * 1. Реализовать этот тип по аналогии с HappyDog.
     * 2. Грустная собака должна перекрашиваться в оттенки синего.
     * 3. (сложно) Перенести метод GetSpriteRenderer в более подходящее место.
     */
    
    /**
     * Детали решения:
     * 1. Схема реализации обоих классов одинаковая:
     *    - Конструктор. Инициализация компонентов перемещения и лая.
     *    - ChangeColor. Установка целевой компоненты цвета в переопределенном методе транзитно связанным в родительском классе с пользовательским вводом.
     * 2. Так как первоначальный спрайт dog_sad.png был зеленого цвета при наложении синего компонента итоговый цвет становился темно-серым.
     *    Для устранения этого эффекта я переделал картинку в чёрно-белую и высветлил до белизны,
     *    а изначалный зеленый цвет получаю путем настройки Color в компоненте Sprite Renderer префаба.
     *    Таким образом достигаются целевые оттенки синих тонов.
     * 3. Метод GetSpriteRenderer и общий код инициализации цветовой компоненты перенесен в родительский класс Dog,
     *    так как он присущ обоим классам.
     */
    public class SadDog : Dog
    {
        public SadDog()
        {
            Move = new Run(this, 1, 2);
            Barkable = new Wail();
        }

        protected override void ChangeColor(float colorComponent)
        {
            GetSpriteRenderer().color = new Color(0.1f, 0.1f, 0.5f + colorComponent / 2);
        }
    }
}